VERSION 5.00
Begin VB.Form formDraftScale 
   Caption         =   "Draft Scale V1.0.0  fr Solid Edge"
   ClientHeight    =   3420
   ClientLeft      =   1770
   ClientTop       =   2190
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3420
   ScaleWidth      =   6030
   Begin VB.Frame Frame3 
      Caption         =   " Mastab in Zeichnung eintragen "
      ForeColor       =   &H00FF0000&
      Height          =   1050
      Left            =   90
      TabIndex        =   5
      Top             =   2295
      Width           =   3750
      Begin VB.Frame Frame4 
         Appearance      =   0  '2D
         Caption         =   "siritec.com"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   -1  'True
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   285
         Left            =   2340
         TabIndex        =   8
         Top             =   675
         Width           =   1320
      End
      Begin VB.TextBox txtUsedScales 
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   11.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   345
         Left            =   90
         TabIndex        =   7
         Text            =   "1:1 (2:1; 5:1; 10:1)"
         Top             =   225
         Width           =   3570
      End
      Begin VB.CommandButton cmdWriteScales 
         Caption         =   "OK"
         Height          =   330
         Left            =   90
         TabIndex        =   6
         Top             =   630
         Width           =   1250
      End
   End
   Begin VB.ListBox listScaleFactorsRaw 
      Height          =   1230
      Left            =   4410
      TabIndex        =   3
      Top             =   990
      Width           =   1500
   End
   Begin VB.Frame Frame2 
      Caption         =   " Mastab der Hauptansicht markieren "
      ForeColor       =   &H00FF0000&
      Height          =   1545
      Left            =   90
      TabIndex        =   1
      Top             =   720
      Width           =   3750
      Begin VB.ListBox listScaleFactors 
         Height          =   1230
         Left            =   90
         TabIndex        =   2
         Top             =   225
         Width           =   3570
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   " Mastbe aus Zeichnung auslesen "
      ForeColor       =   &H00FF0000&
      Height          =   645
      Left            =   90
      TabIndex        =   0
      Top             =   45
      Width           =   3750
      Begin VB.CommandButton cmdReadScales 
         Caption         =   "OK"
         Height          =   330
         Left            =   90
         TabIndex        =   4
         Top             =   225
         Width           =   1250
      End
   End
   Begin VB.Line TrennLinie 
      X1              =   4000
      X2              =   4000
      Y1              =   90
      Y2              =   3330
   End
End
Attribute VB_Name = "formDraftScale"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'================================================================================================================
'DraftScale liest alle in einer SolidEdge Zeichnung verwendeten Mastbe aus
'und trgt diese in den Zeichnungskopf ein
'
'Copyright (c)2004 - siritec.com
'
'Als Programmvorlage diente das VB-Programm "DftScale.vbp",
'welches "Pablo" am 31.Jul.2002 im Solid Edge-Forum auf
'"www.cad.de" gepostet hat. Vielen Dank!
'
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

'Eine deutsche bersetzung der GNU General Public License kann unter
'"http://www.gnu.de/gpl-ger.html" eingesehen werden.
'================================================================================================================


Option Explicit
Public sProgramRelease As String
Public sFormTitel As String
Public sFehlerMeldungberschrift As String
Public sHinweisMeldungberschrift As String

Dim dScaleFactors() As Double
Dim dScaleFactor As Double
Dim sScaleFactor, sScaleFactorRaw As String

Dim sHauptMastab As String
Dim sZusatzMastab As String
Dim sUsedScales As String
Dim sMastabTextBoxGruppenName As String

'SolidEdge-Objekte
'Public objApp As SolidEdgeFramework.Application   'diese Deklaration nur fr die Programmentwicklung verwenden, "objApp.ActiveDocumentType <> 2" funktioniert komischerweise mit dieser Deklaration nicht richtig
Public objApp As Object
'Public objDraft As SolidEdgeDraft.DraftDocument 'diese Deklaration nur fr die Programmentwicklung verwenden, "objApp.ActiveDocumentType <> 2" funktioniert komischerweise mit dieser Deklaration nicht richtig
Public objDraft As Object
Public objSheet As SolidEdgeDraft.Sheet
Public objDrawingView As SolidEdgeDraft.DrawingView
Public SETextbox As Object

'Funktionsdeklaration Fenster im Vordergrund
Private Declare Function SetWindowPos Lib "User32" _
    (ByVal hWnd As Long, ByVal Order As Long, ByVal X As Long, _
    ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, _
    ByVal Flags As Long) As Long




Private Sub cmdReadScales_Click()
    
    Dim i, j, k As Long
    Dim bWertVorhanden As Boolean
    
    bWertVorhanden = False
    listScaleFactors.Clear
    listScaleFactorsRaw.Clear
    txtUsedScales.Text = ""

    ' Turn on error trapping.
    On Error Resume Next

    'Verbindung zu Solid Edge Draft aufbauen
    Set objApp = Nothing
    Set objApp = GetObject(, "SolidEdge.Application")
    
    If Err Then
        'Solid Edge is not running.  Clear the previous error.
        Call FehlerMeldung("Keine Verbindung zu Solid Edge, zuerst Solid Edge starten und erneut probieren...", sFehlerMeldungberschrift)
        Err.Clear
        'Call EinstellungenFunktionsEnde
        Exit Sub
    End If

    'Make Solid Edge visible.
    objApp.Visible = True
    
    'Open the document.
    Set objDraft = Nothing
    Set objDraft = objApp.ActiveDocument
    
    
    If Err Then
        'keine SE-Datei geffnet.  Clear the previous error.
        Call FehlerMeldung("Aktuell ist keine Solid-Edge-Datei geffnet, zuerst Draft-Datei ffnen und erneut probieren...", sFehlerMeldungberschrift)
        Err.Clear
        'Call EinstellungenFunktionsEnde
        Exit Sub
    End If
    
    'falls keine Draft-Datei aktiv ist
    If objApp.ActiveDocumentType <> 2 Then
        ' keine Draft datei geffnet.  Clear the previous error.
        Call FehlerMeldung("Aktuell ist keine Draft-Datei aktiv, zuerst Draft-Datei aktivieren und erneut probieren...", sFehlerMeldungberschrift)
        Err.Clear
        'Call EinstellungenFunktionsEnde
        Exit Sub
    End If
    
    'DraftScales auslesen
    If objDraft.ActiveSheet.DrawingViews.Count = 0 Then
        Call FehlerMeldung("Es sind keine Ansichten in der Zeichnung vorhanden." & vbNewLine & _
                           "Ein Mastab kann deshalb nicht ausgelesen werden.", sHinweisMeldungberschrift)
        Exit Sub
    End If
    
    'Array mit "0" Initialisieren
    ReDim dScaleFactors(objDraft.ActiveSheet.DrawingViews.Count - 1)
    For i = 0 To UBound(dScaleFactors, 1)
        dScaleFactors(i) = 0
    Next i
    
    k = 0
    
    For Each objDrawingView In objDraft.ActiveSheet.DrawingViews
        Debug.Print objDrawingView.ScaleFactor
        dScaleFactor = objDrawingView.ScaleFactor
        
        For i = 0 To UBound(dScaleFactors, 1)
            'listUsedScaleFactors.ListIndex = i
            'Debug.Print listUsedScaleFactors.List(listUsedScaleFactors.ListIndex)
            If dScaleFactors(i) = dScaleFactor Then
                bWertVorhanden = True
            End If
        Next i
        
        If bWertVorhanden = False Then
            dScaleFactors(k) = dScaleFactor
            'listScaleFactors.AddItem (dScaleFactor)
            k = k + 1
        End If
        bWertVorhanden = False
    Next
    
    For i = 0 To UBound(dScaleFactors, 1)
        Debug.Print "ScaleFactors: " & i & " " & dScaleFactors(i)
    Next i
    Debug.Print k
    
    ReDim Preserve dScaleFactors(k - 1)
    
    For i = 0 To UBound(dScaleFactors, 1)
        Debug.Print "ScaleFactors: " & i & " " & dScaleFactors(i)
    Next i
    Debug.Print UBound(dScaleFactors, 1)
    
    'Array sortieren
    Call BubbleSort
    
    For i = 0 To UBound(dScaleFactors, 1)
        Debug.Print "ScaleFactors (sortiert): " & i & " " & dScaleFactors(i)
    Next i
    
    'Array in List-Box laden
    For i = UBound(dScaleFactors, 1) To 0 Step -1
        If dScaleFactors(i) > 1 Then
        sScaleFactorRaw = CStr(dScaleFactors(i)) & ":1"
        sScaleFactor = CStr(dScaleFactors(i)) & " : 1"
        Else
            sScaleFactorRaw = "1:" & CStr(1 / dScaleFactors(i))
            sScaleFactor = "1 : " & CStr(1 / dScaleFactors(i))
        End If
        listScaleFactorsRaw.AddItem (sScaleFactorRaw)   '"Rohe" Daten, ohne Formatierung
        listScaleFactors.AddItem (sScaleFactor)         'Formatierte Daten
    Next i
    
    'Kleinsten Mastab als Default in ListBox aktivieren
    listScaleFactors.ListIndex = UBound(dScaleFactors, 1)
    
End Sub


'Mastbe in Solid Edge Zeichnung bernehmen
Private Sub cmdWriteScales_Click()
    On Error Resume Next
    
    Dim lGruppenNummer, lGruppenNummerMastab As Long
    Dim lTextBoxNummer As Long
        
    lGruppenNummerMastab = -1
    
    'nach der Gruppe mit der Mastabs-Textbox suchen
    With objDraft.ActiveSheet.Background.Groups
        For lGruppenNummer = 1 To .Count
            If (.Item(lGruppenNummer).UserDefinedName = sMastabTextBoxGruppenName) Then
                'bErgebnis = True
                lGruppenNummerMastab = lGruppenNummer
                'MsgBox lGruppenNummer
                
                For lTextBoxNummer = 1 To .Item(lGruppenNummer).TextBoxes.Count
                    .Item(lGruppenNummer).TextBoxes(lTextBoxNummer).Text = txtUsedScales.Text   'in alle TextBoxen der Gruppe den Mastab eintragen
                Next
                
                Exit For
            End If
        Next lGruppenNummer
    End With
            
End Sub


Private Sub Form_Activate()

    Debug.Print "---> Form_Activate"
    
    'Einen Refresh (neuzeichnen) des Fensters erzwingen
    'um Darstellungsfehler unter Win2k beim ersten Zeichnen der Form zu beheben
    'erstes Zeichnen des Fensters, etwas grsser
    Dim lOffset As Long
    lOffset = 10
    Me.Height = Me.Height + lOffset
    Me.Width = Me.Width + lOffset
    'Refresh, neuzeichnen des Fensters in seiner ursprnglichen grsse
    Me.Height = Me.Height - lOffset
    Me.Width = Me.Width - lOffset

End Sub


Private Sub Form_Load()
    On Error Resume Next
    
    Debug.Print "---> Form_Load"
    
    Me.BorderStyle = vbFixedSingle   'gre nicht nderbar
    Me.Width = 4000
    
    sProgramRelease = "1.0.alpha"
    sFormTitel = "Draft Scale V" & sProgramRelease & "  fr Solid Edge"
    Me.Caption = sFormTitel    'FormTitel
    sFehlerMeldungberschrift = Me.Caption & "  <Fehlermeldung>"    'berschrift fr Fehlermeldung
    sHinweisMeldungberschrift = Me.Caption & "  <Hinweis>"         'berschrift fr Hinweismeldung
    
    sMastabTextBoxGruppenName = "DraftScales"  'Name der Gruppe mit den TextBoxen fr den Mastabseintrag
    
    TrennLinie.Visible = False
    txtUsedScales.Text = ""
    
    'Fenster immer im Vordergrund
    Call SetTopMost(Me, True, False)  'FormName, immer im Vordergrund/Normal, aktiv
    
End Sub


'=================================
'MessageBox-Fehlermeldung anzeigen
'=================================
Public Sub FehlerMeldung(sFehlerMeldung As String, sUeberschrift As String)
    MsgBox sFehlerMeldung, vbOKOnly + vbInformation, sUeberschrift
End Sub


'==============================================================
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!
'==============================================================
Private Sub BubbleSort()
  Dim LB&, UB&, TEMP$, Pos&, X&
    
    LB = LBound(dScaleFactors)
    UB = UBound(dScaleFactors)
    
    While UB > LB
      Pos = LB
      
      For X = LB To UB - 1
        If dScaleFactors(X) > dScaleFactors(X + 1) Then
          TEMP = dScaleFactors(X + 1)
          dScaleFactors(X + 1) = dScaleFactors(X)
          dScaleFactors(X) = TEMP
          Pos = X
        End If
      Next X
      
      UB = Pos
    Wend
End Sub


'================================================================================================
'VB 's Trim function only trims space characters (" ") from the beginning or the end of a string.
'This alternative trims all nonprinting characters (tabs, character returns, etc.)
'This Function ist from: www.codetoad.com
'================================================================================================
Public Function TrimComplete(ByVal sValue As String) As String

        Dim sAns As String
        Dim sWkg As String
        Dim sChar As String
        Dim lLen As Long
        Dim lCtr As Long

        sAns = sValue
        lLen = Len(sValue)

        If lLen > 0 Then
            'Ltrim
            For lCtr = 1 To lLen
                sChar = Mid(sAns, lCtr, 1)
                If Asc(sChar) > 32 Then Exit For
            Next

            sAns = Mid(sAns, lCtr)
            lLen = Len(sAns)

            'Rtrim
            If lLen > 0 Then
                For lCtr = lLen To 1 Step -1
                    sChar = Mid(sAns, lCtr, 1)
                    If Asc(sChar) > 32 Then Exit For
                Next
            End If
            sAns = Left$(sAns, lCtr)
        End If

        TrimComplete = sAns

End Function


Private Sub Form_Paint()
    Debug.Print "---> Form_Paint"
End Sub


Private Sub Form_Resize()
    Debug.Print "---> Form_Resize"
End Sub


Private Sub Form_Unload(Cancel As Integer)
    'Objekte aus dem Speicher entfernen
    Set SETextbox = Nothing
    Set objDrawingView = Nothing
    Set objSheet = Nothing
    Set objDraft = Nothing
    Set objApp = Nothing
    
End Sub


Private Sub listScaleFactors_Click()
    Dim lAktiverIndex As Long
    
    Dim i As Long
    Dim bErsterEintrag As Boolean
     
     
    If listScaleFactors.ListIndex = -1 Then
        Call FehlerMeldung("Es wurde noch kein Hauptmastab ausgewhlet.", sFehlerMeldungberschrift)
        Exit Sub
    Else
        lAktiverIndex = listScaleFactors.ListIndex
        listScaleFactorsRaw.ListIndex = lAktiverIndex
    End If
     
    sHauptMastab = Trim(listScaleFactorsRaw.List(listScaleFactorsRaw.ListIndex))
    
    listScaleFactorsRaw.RemoveItem (listScaleFactorsRaw.ListIndex)  'Hauptmastab herausnehmen
    
    sZusatzMastab = ""
    bErsterEintrag = True
    
    For i = listScaleFactorsRaw.ListCount - 1 To 0 Step -1
        listScaleFactorsRaw.ListIndex = i
        If bErsterEintrag = True Then
            sZusatzMastab = sZusatzMastab & Trim(listScaleFactorsRaw.List(listScaleFactorsRaw.ListIndex))
            bErsterEintrag = False
        Else
            sZusatzMastab = sZusatzMastab & "; " & Trim(listScaleFactorsRaw.List(listScaleFactorsRaw.ListIndex))
        End If
    Next i
    
    sZusatzMastab = "(" & sZusatzMastab & ")"
    sUsedScales = sHauptMastab & " " & sZusatzMastab
    'MsgBox lAktiverIndex & vbNewLine & sHauptMastab & vbNewLine & sZusatzMastab & vbNewLine & sUsedScales
    
    txtUsedScales.Text = sUsedScales
    
    'listScaleFactorsRaw wieder neu auffllen
    listScaleFactorsRaw.Clear
    'Array erneut in List-Box laden
    For i = UBound(dScaleFactors, 1) To 0 Step -1
        If dScaleFactors(i) > 1 Then
        sScaleFactorRaw = CStr(dScaleFactors(i)) & ":1"
        'sScaleFactor = CStr(dScaleFactors(i)) & " : 1"
        Else
            sScaleFactorRaw = "1:" & CStr(1 / dScaleFactors(i))
            'sScaleFactor = "1 : " & CStr(1 / dScaleFactors(i))
        End If
        listScaleFactorsRaw.AddItem (sScaleFactorRaw)
        'listScaleFactors.AddItem (sScaleFactor)
    Next i
     

End Sub


'======================================================
'Die Funktion SetTopMost setzt ein Form
'vor alle anderen Fenster und Forms in den Vordergrund,
'auch wenn es nicht das aktive Fenster ist
'http://www.aboutvb.de/khw/artikel/khwtopmost.htm
'======================================================
Public Function SetTopMost(AnyForm As Form, _
 Optional ByVal State As Boolean = True, _
 Optional ByVal Activate As Boolean = True) As Boolean
  Dim nFlags As Long
  Dim nTopMode As Long
  
  Const SWP_NOMOVE = 2
  Const SWP_NOSIZE = 1
  Const HWND_TOPMOST = -1
  Const HWND_NOTOPMOST = -2
  Const SWP_NOACTIVATE = &H10

  nFlags = SWP_NOMOVE Or SWP_NOSIZE
  If Not Activate Then
    nFlags = nFlags Or SWP_NOACTIVATE
  End If
  Select Case State
    Case True
      nTopMode = HWND_TOPMOST
    Case False
      nTopMode = HWND_NOTOPMOST
  End Select
  SetTopMost = _
   CBool(SetWindowPos(AnyForm.hWnd, nTopMode, 0, 0, 0, 0, nFlags))
End Function

